static char * sccsid = "@(#)  error.c  (v1.7 4/17/90)";

# include "kef.h"

# define A(lab,str)	case lab: s = str; break

#ifdef CHARSPRINTF
extern char * sprintf ();
#else
extern int sprintf();
#endif /* ! CHARSPRINTF */

	char *
kef_error (ret)
	int ret;
{
	char * s;
	char buf [80];
	switch (ret) {
		A(KEF_E_SOME_ERROR,		"Some error");
		A(KEF_E_NODES_USEDUP,	"No more space in database.");
		A(KEF_E_STRING_TWICE,	"String is already in the kef database.");
		A(KEF_E_WRITE_ERROR,	"Write error.");
		A(KEF_E_READ_ERROR,		"Read error.");
		A(KEF_E_NOT_FOUND,		"String not found.");
		A(KEF_E_EMPTY_STRING,	"String is empty.");
		A(KEF_E_WRONG_MAGIC,	"Magic number not found on file.");
		A(KEF_E_TOO_MANY_NODES,	"Too many nodes.");
		A(KEF_E_SIZE_KDB,		"Size of kdb.");
		A(KEF_E_SIZE_NODE,		"Size of node array.");
		A(KEF_E_NO_MALLOC,		"I don't know a malloc like routine to call.");
		A(KEF_E_NO_REALLOC,		"I don't know a realloc like routine to call.");
		A(KEF_E_NO_FREE,		"I don't know a free like routine to call.");
		A(KEF_E_ALLOC_FAILED,	"Allocation failed.");
		A(KEF_E_CHECK,			"Checking found error.");
		A(KEF_E_INV_PAR,		"buf != NULL but buf_size <= 0.");
		A(KEF_E_INV_INX,		"Invalid index encountered.");
		A(KEF_E_TAG_LOOP,		"Loop while travelling along tags.");
		
		default:
			(void) sprintf (buf, "** kef error %1d **", ret);
			s = buf;
			break;
	}
	return (s);
}
