static char * sccsid = "@(#)  advance.c  (v2.2 3/21/90)";

# include <stdio.h>
# include "kef.h"

#ifdef DEBUG_WALK
#	define L_DEBUG
#else
#	ifdef L_DEBUG
#		undef L_DEBUG
#	endif
#endif
# include "local.h"

kef_advance (kdb, c, pos)
	struct kef_db * kdb;
	char c;
	kef_index * pos;
/*
 * Look in list below cell *pos for character c.
 * found :
 *		return 1 and set *pos to index at which character was found
 * not found:
 *		return 0 and don't change value at *pos
 */
{
	DI("kef_advance ::")
	int i;
	kef_index found;

	if (*pos == KEF_NIL)
		*pos = kdb->root;

	/*
	 * Use flocate because we are only interested in the position
	 * at which character is.
	 */
	i = kef__flocate_node (kdb->node, c, *pos, &found);
	if (i != 0)
		*pos = found;

	DEB3("%s return value == %1d, pos = %1d\n", i, *pos);
	FLUSH;
	return i == 0 ? 0 : 1;
}
